.\"
.\" Copyright (c) 1996 Julian Elischer
.\"
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/at_fork.9,v 1.2.2.2 1999/09/05 11:27:13 peter Exp $
.\" "
.Dd August 15, 1996
.Os
.Dt AT_FORK 9
.Sh NAME
.Nm at_fork ,
.Nm rm_at_fork
.Nd ask that a function be run at fork.
.Sh SYNOPSIS
.Fd #include <sys/systm.h>
.Ft typedef void \*(lp*forklist_fn\*(rp \*(lpstruct proc*, struct proc*, int\*(rp;
.Ft void
.Fn at_fork "forklist_fn func"
.Ft void
.Fn rm_at_fork "forklist_fn func"
.Sh DESCRIPTION
The
.Nm at_fork
facility allows a kernel module to ensure that it is notified
at any process fork.
The function
.Fa func
is called with the a pointer to the forking process's proc structure,
a pointer to the child's process structure and a flag word,
as used in
.Xr rfork 2
to indicate the type of fork.
.Pp
If the requirement for notification is removed, then the function 
.Fn rm_at_fork
must be called with the exact
.Fa func
argument as the corresponding call to
.Fn at_fork .
.Pp
.Sh RETURN VALUES
.Fn at_fork
returns an errno, 0 meaning success. 
.Fn rm_at_fork
returns the number of items removed (should be 0 or 1).
.Sh SEE ALSO
.Xr fork 2
.Sh HISTORY
The
.Fn at_fork
function appeared in
.Fx 2.2 .
.Sh BUGS
Since the fork queue is not sorted
and items are added to the head, order of execution 
is reversed to that of insertion.
.Sh AUTHORS
The function was written by
.ie Julian Elischer  (julian@freebsd.org)
.el Julian Elischer  (julian@freebsd.org)
